/* stack.c
 * A simple integer stack implementation.
 * This implementation uses a linked list.
 */ 
#include <stdlib.h>
#include <stdio.h>
#include "stack.h"

stack_t* newStack(void) {
  stack_t* result = malloc(sizeof (stack_t));
  result->top_p = NULL;
  return result;
}

int pop(stack_t* stack_p) {
  if (stack_p == NULL ||
      stack_p->top_p == NULL) {
    fprintf(stderr,
        "ERROR: pop empty stack\n");
    exit(1); // abort the program
  }
  else {
    int result;
    stackElem_t* result_elem;
    result_elem = stack_p->top_p;
    result = result_elem->value;
    stack_p->top_p = result_elem->next_p;
    free(result_elem);
    return result;
  }
}

void push(stack_t* stack_p, int value) {
  stackElem_t* temp =
      malloc(sizeof (stackElem_t));
  temp->value = value;
  temp->next_p = stack_p->top_p;
  stack_p->top_p = temp;
}

int top(stack_t* stack_p) {
  if (stack_p == NULL ||
      stack_p->top_p == NULL) {
    fprintf(stderr,
        "ERROR: top empty stack\n");
    exit(1); // abort the program
  }
  else
    return stack_p->top_p->value;
}

int empty(stack_t* stack_p) {
  return (stack_p->top_p == NULL);
}
