/* structByValue.c
 * Show that structures are copied.
 */
#include <stdio.h>
#include <string.h>

#define NAME_SIZE 80

typedef struct {
  char last[NAME_SIZE];
  char first[NAME_SIZE];
  double gpa;
  int startYear;
} student_t;

void printRecord(student_t student);
void readRecord(student_t student);

int main() {
  student_t student;

  // initialize all fields
  student.last[0] = '\0';
  student.first[0] = '\0';
  student.gpa = 0;
  student.startYear = 0;

  // the structure is copied
  readRecord(student);
  printRecord(student);
  return 0;
}

void printRecord(student_t student) {
  printf("%s, %s: gpa:%f, year:%d\n",
      student.last, student.first,
      student.gpa, student.startYear);
}

void readRecord(student_t student) {
  student.gpa = 3.5;
  student.startYear = 2000;
  strncpy(student.first,
      "Jane", NAME_SIZE);
  strncpy(student.last,
      "Programmer", NAME_SIZE);
}
